<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%!
String getBioMaterialAtLocation(BioPlate plate, int row, int col)
{
	String name = "empty";
	BioWell well = plate.getBioWell(row, col);
	if (well != null)
	{
		try
		{
			BioMaterial bm = well.getBioMaterial();
			if (bm != null)
			{
				name = HTML.encodeTags(bm.getName());
			}
		}
		catch (PermissionDeniedException ex)
		{
			name = "permission denied";
		}
	}
	return name;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final int BLOCKS_PER_PAGE = 3;
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	List<BioPlate> plates = new ArrayList<BioPlate>();
	for (String id : request.getParameterValues("plates"))
	{
		plates.add(BioPlate.getById(dc, Values.getInt(id)));
	}
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<link rel="stylesheet" type="text/css" href="<%=home %>/css/printable.css">
	<style>
	
	div.parffinblock
	{
		margin-top: 1em;
		height: 7cm;
	}
	
	div.parffinblock > table
	{
		width: 100%;
		height: 6cm;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	div.parffinblock > table > tbody > tr > td
	{
		vertical-align: top;
		border: 1px solid #000000;
	}
	
	</style>
</head>
<body>
	<div class="noprint fullwidth" style="border-bottom: 1px dashed #A0A0A0; padding-left: 1em; padding-bottom: 1em;">
		<a href="javascript:window.print()"><img src="images/print.png" style="padding-right: 4px;">Print</a>
	</div>
	<%
	int pageNo = 0;
	int totalPages = 1 + (plates.size() - 1) / BLOCKS_PER_PAGE;
	for (int blockNo = 0; blockNo < plates.size(); ++blockNo)
	{
		BioPlate plate = plates.get(blockNo);
		if (blockNo % BLOCKS_PER_PAGE == 0)
		{
			pageNo++;
			%>
			<div class="<%=blockNo > 0 ? "pagebreak" : ""%>"></div>
			<h1>Lab Tracking protocol for FFPE/HE v.1.0</h1>
			<table style="width: 100%; border: 0px;">
			<tr>
				<td colspan="2">Reggie <%=reggie.getAbout().getVersion() %>; Page <%=pageNo %> of <%=totalPages %></td>
			</tr>
			<tr>
				<td><b>Start date:</b></td>
				<td><b>Operator:</b></td>
			</tr>
			</table>
			<%
		}
		%>
		<div class="parffinblock">
			<b>Block: </b><%=HTML.encodeTags(plate.getName()) %>
			<table>
				<tr>
				<td>
					<b>3</b>: <%=getBioMaterialAtLocation(plate, 0, 0) %>
				</td>
				<td>
					<b>6</b>
				</td>
				</tr>
				
				<tr>
				<td>
					<b>2</b>: <%=getBioMaterialAtLocation(plate, 1, 0) %>
				</td>
				<td>
					<b>5</b>: <%=getBioMaterialAtLocation(plate, 1, 1) %>
				</td>
				</tr>
				
				<tr>
				<td>
					<b>1</b>: <%=getBioMaterialAtLocation(plate, 2, 0) %>
				</td>
				<td>
					<b>4</b>: <%=getBioMaterialAtLocation(plate, 2, 1) %>
				</td>
				</tr>
			</table>
		</div>
		<%
	}
	%>
	
</body>
</html>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>